# Quarn OS
#
# Makefile for modules
#
# Copyright (C) 2008-2009 Pawel Dziepak
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#


.SUFFIXES : .ko

MANES =	loader.o \
	elf.o \
	module.o

MODULE = rs232.ko

MODULE_LIBS = ../libs/string.o #../manes/rtti.o

OBJS = modules_start.o ../manes/cds/component.o ../resources/rs232.o ../arch/low/rs232.o ../arch/low/lowlevel.o ../resources/device.o $(MODULE_LIBS)

modules: dep.d compile

compile: $(MODULE) $(MANES)

dep.d:
		@echo -e "\t\t[dep]\tmodules"
		@$(CPP) $(CPPFLAGS) -M *.cpp > dep.d

rs232.ko: $(OBJS)
		@echo -e "\t\t[$(CPP)] M\tmodules/$*.ko"
		@$(CPP) $(CPPFLAGS) -shared -fpic -e start_module $(OBJS) -o $*.ko
		@#strip $*.ko

.c.o:
		@echo -e "\t\t[$(CC)]\tmodules/$*.c"
		@$(CC) $(CFLAGS) -c $*.c -o $*.o

.cpp.ko:
		@echo -e "\t\t[$(CPP)]\tmodules/$*.cpp"
		@$(CPP) $(CPPFLAGS) -c $*.cpp -o $*.o

.cpp.o:
		@echo -e "\t\t[$(CPP)]\tmodules/$*.cpp"
		@$(CPP) $(CPPFLAGS) -c $*.cpp -o $*.o

clean:
		@echo -e "\t\t[rm]\tmodules"
		@-rm -f dep.d
		@rm -f *.o *.ko

ifeq ($(MAKECMDGOALS),)
-include dep.d
endif